/****************************************************************************

 MESSAGE PASSING INTERFACE TEST CASE SUITE

 Copyright IBM Corp. 1995

 IBM Corp. hereby grants a non-exclusive license to use, copy, modify, and
 distribute this software for any purpose and without fee provided that the
 above copyright notice and the following paragraphs appear in all copies.

 IBM Corp. makes no representation that the test cases comprising this
 suite are correct or are an accurate representation of any standard.

 In no event shall IBM be liable to any party for direct, indirect, special
 incidental, or consequential damage arising out of the use of this software
 even if IBM Corp. has been advised of the possibility of such damage.

 IBM CORP. SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED
 TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS AND IBM
 CORP. HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
 ENHANCEMENTS, OR MODIFICATIONS.

****************************************************************************

 These test cases reflect an interpretation of the MPI Standard.  They are
 are, in most cases, unit tests of specific MPI behaviors.  If a user of any
 test case from this set believes that the MPI Standard requires behavior
 different than that implied by the test case we would appreciate feedback.

 Comments may be sent to:
    Richard Treumann
    treumann@kgn.ibm.com

****************************************************************************
*/
//#include "mpi.h"
import mpi.*;

class bsend {
  static public void main(String[] args) {
    /* Note that the buffer sizes must include the BSEND_OVERHEAD;
       these values are probably sizeof(int) too large */
    //int *oldbuf;
    int len,tasks,me,i,size,rc;
    //int data[100000],buf1[1000],buf2[100000];
    //MPI_Status status;
    Status status;

    //MPI_Init(0,0);
    //MPI_Comm_rank(MPI_COMM_WORLD,&me);
    //MPI_Errhandler_set(MPI_COMM_WORLD,MPI_ERRORS_RETURN);
    MPI.Init(args);
    me=MPI.COMM_WORLD.Rank();


    //int data1[] = new int[asize];
    int data1[] = new int[1000];
    int data100[] = new int[100000];
    int intsize = 4;
    byte buf1[] = new byte[1000*intsize+MPI.BSEND_OVERHEAD];
    //byte buf2[] = new byte[asize*intsize+MPI.BSEND_OVERHEAD];
    byte buf100[] = new byte[100000*intsize+MPI.BSEND_OVERHEAD];

    if(me==0) {
      
      //MPI_Buffer_attach(buf1,sizeof(buf1));
      MPI.Buffer_attach(buf1);  
      //MPI_Bsend(data,1000,MPI_INT,1,1,MPI_COMM_WORLD);
      MPI.COMM_WORLD.Bsend(data1,0,1000,MPI.INT,1,1);
      //MPI_Buffer_detach(&oldbuf,&size);
      MPI.Buffer_detach(buf1);
      /* 
      if(oldbuf != buf1)
	System.out.println
	  ("ERROR in MPI_Buffer_detach, incorrect buffer returned\n");
      if(size != sizeof(buf1))
	System.out.println
	  ("ERROR in MPI_Buffer_detach, incorrect size returned\n");
      */ 


      //MPI_Buffer_attach(buf2,sizeof(buf2));
      MPI.Buffer_attach(buf100);
      //MPI_Bsend(data,1001,MPI_INT,1,1,MPI_COMM_WORLD);
      //99MPI.COMM_WORLD.Bsend(data,0,1001,MPI.INT,1,1);

      //MPI_Barrier(MPI_COMM_WORLD);
      MPI.COMM_WORLD.Barrier();

/* test to see if large array is REALLY being buffered */
      for(i=0;i<100000;i++)  data100[i] = 1;
      //MPI_Bsend(data,100000,MPI_INT,1,1,MPI_COMM_WORLD);
      MPI.COMM_WORLD.Bsend(data100,0,100000,MPI.INT,1,1);
      //MPI_Recv(data,100000,MPI_INT,1,2,MPI_COMM_WORLD,&status);
      MPI.COMM_WORLD.Recv(data100,0,100000,MPI.INT,1,2);
      for(i=0;i<100000;i++)
	if(data100[i] != 2)  
	  System.out.println
	    ("ERROR, incorrect data["+i+"]="+data100[i]+", task 0");

	      
      //rc = MPI_Bsend(data,100001,MPI_INT,1,1,MPI_COMM_WORLD);
      //if(rc != MPI_SUCCESS)  printf("ERROR: Buffer overflow not detected\n");
    } else if(me == 1) {
      //MPI_Recv(data,1000,MPI_INT,0,1,MPI_COMM_WORLD,&status);
      //MPI_Recv(data,1001,MPI_INT,0,1,MPI_COMM_WORLD,&status);
      MPI.COMM_WORLD.Recv(data1,0,1000,MPI.INT,0,1);
      //MPI.COMM_WORLD.Recv(data1,0,1001,MPI.INT,0,1);

      //MPI_Barrier(MPI_COMM_WORLD);
      MPI.COMM_WORLD.Barrier();

      //MPI_Buffer_attach(buf2,sizeof(buf2));
      MPI.Buffer_attach(buf100);

/* test to see if large array is REALLY being buffered */
      for(i=0;i<100000;i++)  data100[i] = 2;
      //MPI_Bsend(data,100000,MPI_INT,0,2,MPI_COMM_WORLD);
      MPI.COMM_WORLD.Bsend(data100,0,100000,MPI.INT,0,2);
      
      //MPI_Recv(data,100000,MPI_INT,0,1,MPI_COMM_WORLD,&status);
      MPI.COMM_WORLD.Recv(data100,0,100000,MPI.INT,0,1);

      for(i=0;i<100000;i++)
	if(data100[i] != 1)  
	  System.out.println
	    ("ERROR , incorrect data["+i+"]="+data100[i]+", task 1");

    }
    //MPI_Barrier(MPI_COMM_WORLD);
    MPI.COMM_WORLD.Barrier();
    if(me == 0)  System.out.println("Bsend TESTS COMPLETE\n");
    MPI.Finalize();
  }
}


